jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
| 40 | tmp_dir="${TMPDIR}/$USER/${test_dir}" |
| 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | |
| 44 | export JAVA="java" |
Brian Carlstrom | 5103ce6 | 2014-03-30 16:17:42 -0700 | [diff] [blame] | 45 | export JAVAC="javac -g" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 46 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 47 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 48 | export NEED_DEX="true" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 49 | export USE_JACK="false" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 50 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 51 | # If dx was not set by the environment variable, assume it is in the path. |
| 52 | if [ -z "$DX" ]; then |
| 53 | export DX="dx" |
| 54 | fi |
| 55 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 56 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 57 | if [ -z "$JASMIN" ]; then |
| 58 | export JASMIN="jasmin" |
| 59 | fi |
| 60 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 61 | # If smali was not set by the environment variable, assume it is in the path. |
| 62 | if [ -z "$SMALI" ]; then |
| 63 | export SMALI="smali" |
| 64 | fi |
| 65 | |
| 66 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 67 | if [ -z "$DXMERGER" ]; then |
| 68 | export DXMERGER="dexmerger" |
| 69 | fi |
| 70 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 71 | # If jack was not set by the environment variable, assume it is in the path. |
| 72 | if [ -z "$JACK" ]; then |
| 73 | export JACK="jack" |
| 74 | fi |
| 75 | |
| 76 | # If the tree is compiled with Jack, build test with Jack by default. |
| 77 | if [ "$ANDROID_COMPILE_WITH_JACK" = "true" ]; then |
| 78 | USE_JACK="true" |
| 79 | fi |
| 80 | |
| 81 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 82 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 83 | export ANDROID_BUILD_TOP=$oldwd |
| 84 | fi |
| 85 | |
| 86 | # If JACK_VM_COMMAND is not set, assume it launches the prebuilt jack-launcher. |
| 87 | if [ -z "$JACK_VM_COMMAND" ]; then |
| 88 | if [ ! -z "$TMPDIR" ]; then |
| 89 | jack_temp_dir="-Djava.io.tmpdir=$TMPDIR" |
| 90 | fi |
| 91 | export JACK_VM_COMMAND="java -Dfile.encoding=UTF-8 -Xms2560m -XX:+TieredCompilation $jack_temp_dir -jar $ANDROID_BUILD_TOP/prebuilts/sdk/tools/jack-launcher.jar" |
| 92 | fi |
| 93 | |
| 94 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 95 | if [ -z "$JACK_CLASSPATH" ]; then |
| 96 | export JACK_CLASSPATH="$ANDROID_BUILD_TOP/out/host/common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack" |
| 97 | fi |
| 98 | |
| 99 | # If JACK_JAR is not set, assume it is located in the prebuilts directory. |
| 100 | if [ -z "$JACK_JAR" ]; then |
| 101 | export JACK_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jack.jar" |
| 102 | fi |
| 103 | |
| 104 | # If JILL_JAR is not set, assume it is located in the prebuilts directory. |
| 105 | if [ -z "$JILL_JAR" ]; then |
| 106 | export JILL_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jill.jar" |
| 107 | fi |
| 108 | |
| 109 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
| 110 | export JILL="java -jar $JILL_JAR" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 111 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 112 | info="info.txt" |
| 113 | build="build" |
| 114 | run="run" |
| 115 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 116 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 117 | output="output.txt" |
| 118 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 119 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame^] | 120 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 121 | lib="libartd.so" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 122 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 123 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 124 | |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 125 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 126 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 127 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 128 | dev_mode="no" |
| 129 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 130 | debug_mode="no" |
| 131 | relocate="yes" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 132 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 133 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 134 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 135 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 136 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 137 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 138 | basic_verify="false" |
| 139 | gc_verify="false" |
| 140 | gc_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame^] | 141 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 142 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 143 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 144 | have_dex2oat="yes" |
| 145 | have_patchoat="yes" |
| 146 | have_image="yes" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 147 | image_suffix="" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 148 | pic_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 149 | android_root="/system" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 150 | |
| 151 | while true; do |
| 152 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 153 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 154 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 155 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 156 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 157 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 158 | target_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 159 | runtime="jvm" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 160 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 161 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 162 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 163 | run_args="${run_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 164 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 165 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 166 | lib="libart.so" |
| 167 | shift |
| 168 | elif [ "x$1" = "x--dalvik" ]; then |
| 169 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 170 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 171 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 172 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 173 | have_dex2oat="no" |
| 174 | shift |
| 175 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 176 | have_patchoat="no" |
| 177 | shift |
| 178 | elif [ "x$1" = "x--no-image" ]; then |
| 179 | have_image="no" |
| 180 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 181 | elif [ "x$1" = "x--pic-image" ]; then |
| 182 | pic_image_suffix="-pic" |
| 183 | shift |
| 184 | elif [ "x$1" = "x--pic-test" ]; then |
| 185 | run_args="${run_args} --pic-test" |
| 186 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 187 | elif [ "x$1" = "x--relocate" ]; then |
| 188 | relocate="yes" |
| 189 | shift |
| 190 | elif [ "x$1" = "x--no-relocate" ]; then |
| 191 | relocate="no" |
| 192 | shift |
| 193 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 194 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 195 | prebuild_mode="yes" |
| 196 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 197 | elif [ "x$1" = "x--debuggable" ]; then |
| 198 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 199 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 200 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 201 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 202 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 203 | prebuild_mode="no" |
| 204 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 205 | elif [ "x$1" = "x--gcverify" ]; then |
| 206 | basic_verify="true" |
| 207 | gc_verify="true" |
| 208 | shift |
| 209 | elif [ "x$1" = "x--gcstress" ]; then |
| 210 | basic_verify="true" |
| 211 | gc_stress="true" |
| 212 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 213 | elif [ "x$1" = "x--image" ]; then |
| 214 | shift |
| 215 | image="$1" |
| 216 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 217 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 218 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 219 | shift |
| 220 | option="$1" |
| 221 | run_args="${run_args} -Xcompiler-option $option" |
| 222 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 223 | elif [ "x$1" = "x--runtime-option" ]; then |
| 224 | shift |
| 225 | option="$1" |
| 226 | run_args="${run_args} --runtime-option $option" |
| 227 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 228 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 229 | shift |
| 230 | gdb_arg="$1" |
| 231 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 232 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 233 | elif [ "x$1" = "x--debug" ]; then |
| 234 | run_args="${run_args} --debug" |
| 235 | shift |
| 236 | elif [ "x$1" = "x--gdb" ]; then |
| 237 | run_args="${run_args} --gdb" |
| 238 | dev_mode="yes" |
| 239 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame^] | 240 | elif [ "x$1" = "x--strace" ]; then |
| 241 | strace="yes" |
| 242 | run_args="${run_args} --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
| 243 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 244 | elif [ "x$1" = "x--zygote" ]; then |
| 245 | run_args="${run_args} --zygote" |
| 246 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 247 | elif [ "x$1" = "x--interpreter" ]; then |
| 248 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 249 | image_suffix="-interpreter" |
| 250 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 251 | elif [ "x$1" = "x--jit" ]; then |
| 252 | run_args="${run_args} --jit" |
Mathieu Chartier | e2a12c0 | 2015-02-27 13:21:15 -0800 | [diff] [blame] | 253 | image_suffix="-interpreter" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 254 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 255 | elif [ "x$1" = "x--optimizing" ]; then |
| 256 | run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing" |
| 257 | image_suffix="-optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 258 | shift |
Nicolas Geoffray | c9338b9 | 2014-12-03 13:36:10 +0000 | [diff] [blame] | 259 | elif [ "x$1" = "x--quick" ]; then |
| 260 | run_args="${run_args} -Xcompiler-option --compiler-backend=Quick" |
| 261 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 262 | elif [ "x$1" = "x--no-verify" ]; then |
| 263 | run_args="${run_args} --no-verify" |
| 264 | shift |
| 265 | elif [ "x$1" = "x--no-optimize" ]; then |
| 266 | run_args="${run_args} --no-optimize" |
| 267 | shift |
| 268 | elif [ "x$1" = "x--no-precise" ]; then |
| 269 | run_args="${run_args} --no-precise" |
| 270 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 271 | elif [ "x$1" = "x--invoke-with" ]; then |
| 272 | shift |
| 273 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 274 | if [ "x$what" = "x" ]; then |
| 275 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 276 | usage="yes" |
| 277 | break |
| 278 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 279 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 280 | shift |
| 281 | elif [ "x$1" = "x--dev" ]; then |
| 282 | run_args="${run_args} --dev" |
| 283 | dev_mode="yes" |
| 284 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 285 | elif [ "x$1" = "x--build-only" ]; then |
| 286 | build_only="yes" |
| 287 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 288 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 289 | USE_JACK="false" |
| 290 | shift |
| 291 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 292 | USE_JACK="true" |
| 293 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 294 | elif [ "x$1" = "x--output-path" ]; then |
| 295 | shift |
| 296 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 297 | if [ "x$tmp_dir" = "x" ]; then |
| 298 | echo "$0 missing argument to --output-path" 1>&2 |
| 299 | usage="yes" |
| 300 | break |
| 301 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 302 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 303 | elif [ "x$1" = "x--android-root" ]; then |
| 304 | shift |
| 305 | if [ "x$1" = "x" ]; then |
| 306 | echo "$0 missing argument to --android-root" 1>&2 |
| 307 | usage="yes" |
| 308 | break |
| 309 | fi |
| 310 | android_root="$1" |
| 311 | run_args="${run_args} --android-root $1" |
| 312 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 313 | elif [ "x$1" = "x--update" ]; then |
| 314 | update_mode="yes" |
| 315 | shift |
| 316 | elif [ "x$1" = "x--help" ]; then |
| 317 | usage="yes" |
| 318 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 319 | elif [ "x$1" = "x--64" ]; then |
| 320 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 321 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 322 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 323 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 324 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 325 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 326 | elif [ "x$1" = "x--stream" ]; then |
| 327 | trace_stream="true" |
| 328 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 329 | elif [ "x$1" = "x--always-clean" ]; then |
| 330 | always_clean="yes" |
| 331 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 332 | elif [ "x$1" = "x--never-clean" ]; then |
| 333 | never_clean="yes" |
| 334 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 335 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 336 | run_args="${run_args} --dex2oat-swap" |
| 337 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 338 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 339 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 340 | usage="yes" |
| 341 | break |
| 342 | else |
| 343 | break |
| 344 | fi |
| 345 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 346 | |
| 347 | # tmp_dir may be relative, resolve. |
| 348 | # |
| 349 | # Cannot use realpath, as it does not exist on Mac. |
| 350 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 351 | # Cannot use readlink -m, as it does not exist on Mac. |
| 352 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 353 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 354 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 355 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 356 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 357 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 358 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 359 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 360 | fi |
| 361 | if [ "$gc_verify" = "true" ]; then |
| 362 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 363 | fi |
| 364 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | eb19362 | 2015-06-27 15:42:27 -0700 | [diff] [blame] | 365 | run_args="${run_args} --runtime-option -Xgc:SS,gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 366 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 367 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 368 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 369 | if [ "$trace_stream" = "true" ]; then |
| 370 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 371 | # the ability to analyze the file and just write to /dev/null. |
| 372 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 373 | # Enable streaming mode. |
| 374 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 375 | else |
| 376 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 377 | fi |
| 378 | elif [ "$trace_stream" = "true" ]; then |
| 379 | echo "Cannot use --stream without --trace." |
| 380 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 381 | fi |
| 382 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 383 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 384 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 385 | function guess_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 386 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 387 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 388 | if [ "x${suffix64}" = "x64" ]; then |
| 389 | target_arch_name=${grep64bit} |
| 390 | else |
| 391 | target_arch_name=${grep32bit} |
| 392 | fi |
| 393 | } |
| 394 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 395 | if [ "$target_mode" = "no" ]; then |
| 396 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 397 | if [ "$prebuild_mode" = "yes" ]; then |
| 398 | echo "--prebuild with --jvm is unsupported"; |
| 399 | exit 1; |
| 400 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 401 | fi |
| 402 | fi |
| 403 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 404 | if [ "$have_patchoat" = "no" ]; then |
| 405 | run_args="${run_args} --no-patchoat" |
| 406 | fi |
| 407 | |
| 408 | if [ "$have_dex2oat" = "no" ]; then |
| 409 | run_args="${run_args} --no-dex2oat" |
| 410 | fi |
| 411 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 412 | if [ ! "$runtime" = "jvm" ]; then |
| 413 | run_args="${run_args} --lib $lib" |
| 414 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 415 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 416 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 417 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 418 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 419 | bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
| 420 | run_args="${run_args} --boot -Xbootclasspath:${bpath}" |
| 421 | else |
| 422 | true # defaults to using target BOOTCLASSPATH |
| 423 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 424 | elif [ "$runtime" = "art" ]; then |
| 425 | if [ "$target_mode" = "no" ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 426 | # ANDROID_HOST_OUT is not set in a build environment. |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 427 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 428 | export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86 |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 429 | fi |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 430 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 431 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 432 | else |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 433 | guess_arch_name |
| 434 | run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 435 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 436 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 437 | if [ "$relocate" = "yes" ]; then |
| 438 | run_args="${run_args} --relocate" |
| 439 | else |
| 440 | run_args="${run_args} --no-relocate" |
| 441 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 442 | elif [ "$runtime" = "jvm" ]; then |
| 443 | # TODO: Detect whether the host is 32-bit or 64-bit. |
| 444 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 445 | fi |
| 446 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 447 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 448 | if [ "$runtime" != "art" ]; then |
| 449 | echo "--no-image is only supported on the art runtime" |
| 450 | exit 1 |
| 451 | fi |
| 452 | if [ "$target_mode" = "no" ]; then |
| 453 | framework="${ANDROID_HOST_OUT}/framework" |
| 454 | bpath_suffix="-hostdex" |
| 455 | else |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 456 | framework="${android_root}/framework" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 457 | bpath_suffix="" |
| 458 | fi |
| 459 | # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will |
| 460 | # fail since these jar files will be stripped. |
| 461 | bpath="${framework}/core-libart${bpath_suffix}.jar" |
| 462 | bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar" |
| 463 | bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar" |
| 464 | bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar" |
| 465 | bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar" |
| 466 | # Pass down the bootclasspath |
| 467 | run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 468 | run_args="${run_args} --no-image" |
| 469 | fi |
| 470 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 471 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
| 472 | echo "--dev and --update are mutually exclusive" 1>&2 |
| 473 | usage="yes" |
| 474 | fi |
| 475 | |
| 476 | if [ "$usage" = "no" ]; then |
| 477 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 478 | test_dir=`basename "$oldwd"` |
| 479 | else |
| 480 | test_dir="$1" |
| 481 | fi |
| 482 | |
| 483 | if [ '!' -d "$test_dir" ]; then |
| 484 | td2=`echo ${test_dir}-*` |
| 485 | if [ '!' -d "$td2" ]; then |
| 486 | echo "${test_dir}: no such test directory" 1>&2 |
| 487 | usage="yes" |
| 488 | fi |
| 489 | test_dir="$td2" |
| 490 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 491 | # Shift to get rid of the test name argument. The rest of the arguments |
| 492 | # will get passed to the test run. |
| 493 | shift |
| 494 | fi |
| 495 | |
| 496 | if [ "$usage" = "yes" ]; then |
| 497 | prog=`basename $prog` |
| 498 | ( |
| 499 | echo "usage:" |
| 500 | echo " $prog --help Print this message." |
| 501 | echo " $prog [options] [test-name] Run test normally." |
| 502 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 503 | "(dumps to stdout)." |
| 504 | echo " $prog --update [options] [test-name] Update mode" \ |
| 505 | "(replaces expected.txt)." |
| 506 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 507 | "current directory." |
| 508 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 509 | echo " -O Run non-debug rather than debug build (off by default)." |
| 510 | echo " -Xcompiler-option Pass an option to the compiler." |
| 511 | echo " --runtime-option Pass an option to the runtime." |
| 512 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 513 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 514 | echo " --gdb Run under gdb; incompatible with some tests." |
| 515 | echo " --build-only Build test files only (off by default)." |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 516 | echo " --build-with-javac-dx Build test files with javac and dx (on by default)." |
| 517 | echo " --build-with-jack Build test files with jack and jill (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 518 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 519 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 520 | echo " --optimizing Enable optimizing compiler (default)." |
| 521 | echo " --quick Use Quick compiler (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 522 | echo " --no-verify Turn off verification (on by default)." |
| 523 | echo " --no-optimize Turn off optimization (on by default)." |
| 524 | echo " --no-precise Turn off precise GC (on by default)." |
| 525 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 526 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 527 | echo " other runtime options are ignored." |
| 528 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 529 | echo " --no-patchoat Run as though patchoat was failing." |
| 530 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 531 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 532 | echo " the test." |
| 533 | echo " --relocate Force the use of relocating in the test, making" |
| 534 | echo " the image and oat files be relocated to a random" |
| 535 | echo " address before running. (default)" |
| 536 | echo " --no-relocate Force the use of no relocating in the test" |
| 537 | echo " --host Use the host-mode virtual machine." |
| 538 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 539 | echo " --dalvik Use Dalvik (off by default)." |
| 540 | echo " --jvm Use a host-local RI virtual machine." |
| 541 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 542 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 543 | echo " --64 Run the test in 64-bit mode" |
| 544 | echo " --trace Run with method tracing" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 545 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 546 | echo " --gcstress Run with gc stress testing" |
| 547 | echo " --gcverify Run with gc verification" |
| 548 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 549 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 550 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 551 | echo " --dex2oat-swap Use a dex2oat swap file." |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 552 | ) 1>&2 |
| 553 | exit 1 |
| 554 | fi |
| 555 | |
| 556 | cd "$test_dir" |
| 557 | test_dir=`pwd` |
| 558 | |
| 559 | td_info="${test_dir}/${info}" |
| 560 | td_expected="${test_dir}/${expected}" |
| 561 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 562 | if [ ! -r $td_info ]; then |
| 563 | echo "${test_dir}: missing file $td_info" 1>&2 |
| 564 | exit 1 |
| 565 | fi |
| 566 | |
| 567 | if [ ! -r $td_expected ]; then |
| 568 | echo "${test_dir}: missing file $td_expected" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 569 | exit 1 |
| 570 | fi |
| 571 | |
| 572 | # copy the test to a temp dir and run it |
| 573 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 574 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 575 | |
| 576 | rm -rf "$tmp_dir" |
| 577 | cp -Rp "$test_dir" "$tmp_dir" |
| 578 | cd "$tmp_dir" |
| 579 | |
| 580 | if [ '!' -r "$build" ]; then |
| 581 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 582 | else |
| 583 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 584 | fi |
| 585 | |
| 586 | if [ '!' -r "$run" ]; then |
| 587 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 588 | else |
| 589 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 590 | fi |
| 591 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 592 | if [ '!' -r "$check_cmd" ]; then |
| 593 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 594 | else |
| 595 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 596 | fi |
| 597 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 598 | chmod 755 "$build" |
| 599 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 600 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 601 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 602 | export TEST_NAME=`basename ${test_dir}` |
| 603 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 604 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 605 | # Checker when compiled with Optimizing on host. |
| 606 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
| 607 | # Build Checker DEX files without dx's optimizations so the input to dex2oat |
| 608 | # better resembles the Java source. We always build the DEX the same way, even |
| 609 | # if Checker is not invoked and the test only runs the program. |
| 610 | build_args="${build_args} --dx-option --no-optimize" |
| 611 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 612 | # Jack does not necessarily generate the same DEX output than dx. Because these tests depend |
| 613 | # on a particular DEX output, keep building them with dx for now (b/19467889). |
| 614 | USE_JACK="false" |
| 615 | |
Nicolas Geoffray | e730729 | 2015-03-17 18:12:06 +0000 | [diff] [blame] | 616 | if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" -a "$target_mode" = "no" -a "$debuggable" = "no" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 617 | run_checker="yes" |
| 618 | run_args="${run_args} -Xcompiler-option --dump-cfg=$tmp_dir/$cfg_output \ |
| 619 | -Xcompiler-option -j1" |
| 620 | fi |
| 621 | fi |
| 622 | |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 623 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB. |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 624 | build_file_size_limit=2048 |
| 625 | run_file_size_limit=2048 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 626 | if echo "$test_dir" | grep 089; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 627 | build_file_size_limit=5120 |
| 628 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 629 | elif echo "$test_dir" | grep 083; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 630 | build_file_size_limit=5120 |
| 631 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 632 | fi |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 633 | if [ ${USE_JACK} = "false" ]; then |
| 634 | # Set ulimit if we build with dx only, Jack can generate big temp files. |
| 635 | if ! ulimit -S "$build_file_size_limit"; then |
| 636 | echo "ulimit file size setting failed" |
| 637 | fi |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 638 | fi |
| 639 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 640 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 641 | good_build="yes" |
| 642 | good_run="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 643 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 644 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 645 | build_exit="$?" |
| 646 | echo "build exit status: $build_exit" 1>&2 |
| 647 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 648 | if ! ulimit -S "$run_file_size_limit"; then |
| 649 | echo "ulimit file size setting failed" |
| 650 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 651 | echo "${test_dir}: running..." 1>&2 |
| 652 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 653 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 654 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 655 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 656 | if [ "$run_checker" = "yes" ]; then |
| 657 | "$checker" "$cfg_output" "$tmp_dir" 2>&1 |
| 658 | checker_exit="$?" |
| 659 | if [ "$checker_exit" = "0" ]; then |
| 660 | good="yes" |
| 661 | fi |
| 662 | echo "checker exit status: $checker_exit" 1>&2 |
| 663 | else |
| 664 | good="yes" |
| 665 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 666 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 667 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 668 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 669 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 670 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 671 | build_exit="$?" |
| 672 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 673 | if ! ulimit -S "$run_file_size_limit"; then |
| 674 | echo "ulimit file size setting failed" |
| 675 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 676 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 677 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 678 | if [ "$run_checker" = "yes" ]; then |
| 679 | "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
| 680 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 681 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 682 | good="yes" |
| 683 | else |
| 684 | cat "$build_output" 1>&2 |
| 685 | echo "build exit status: $build_exit" 1>&2 |
| 686 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 687 | elif [ "$build_only" = "yes" ]; then |
| 688 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 689 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 690 | build_exit="$?" |
| 691 | if [ "$build_exit" '!=' '0' ]; then |
| 692 | cp "$build_output" "$output" |
| 693 | echo "build exit status: $build_exit" >>"$output" |
| 694 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 695 | if [ "$?" '!=' "0" ]; then |
| 696 | good="no" |
| 697 | echo "BUILD FAILED For ${TEST_NAME}" |
| 698 | fi |
| 699 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 700 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 701 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 702 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 703 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 704 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 705 | build_exit="$?" |
| 706 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 707 | if ! ulimit -S "$run_file_size_limit"; then |
| 708 | echo "ulimit file size setting failed" |
| 709 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 710 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 711 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 712 | run_exit="$?" |
| 713 | if [ "$run_exit" != "0" ]; then |
| 714 | echo "run exit status: $run_exit" 1>&2 |
| 715 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 716 | elif [ "$run_checker" = "yes" ]; then |
| 717 | "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
| 718 | checker_exit="$?" |
| 719 | if [ "$checker_exit" != "0" ]; then |
| 720 | echo "checker exit status: $checker_exit" 1>&2 |
| 721 | good_run="no" |
| 722 | else |
| 723 | good_run="yes" |
| 724 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 725 | else |
| 726 | good_run="yes" |
| 727 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 728 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 729 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 730 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 731 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 732 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 733 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 734 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 735 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 736 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 737 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 738 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 739 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 740 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 741 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 742 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 743 | # output == expected |
| 744 | good="yes" |
| 745 | echo "${test_dir}: succeeded!" 1>&2 |
| 746 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 747 | fi |
| 748 | fi |
| 749 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 750 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 751 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 752 | echo "${test_dir}: FAILED!" |
| 753 | echo ' ' |
| 754 | echo '#################### info' |
| 755 | cat "${td_info}" | sed 's/^/# /g' |
| 756 | echo '#################### diffs' |
Ian Rogers | 75deec0 | 2014-11-23 20:07:39 -0800 | [diff] [blame] | 757 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 2000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 758 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame^] | 759 | if [ "$strace" = "yes" ]; then |
| 760 | echo '#################### strace output' |
| 761 | tail -n 2000 "$tmp_dir/$strace_output" |
| 762 | echo '####################' |
| 763 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 764 | echo ' ' |
| 765 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 766 | |
| 767 | ) 1>&2 |
| 768 | |
| 769 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 770 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 771 | cd "$oldwd" |
| 772 | rm -rf "$tmp_dir" |
| 773 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 774 | adb shell rm -rf $DEX_LOCATION |
| 775 | fi |
| 776 | if [ "$good" = "yes" ]; then |
| 777 | exit 0 |
| 778 | fi |
| 779 | fi |
| 780 | |
| 781 | |
| 782 | ( |
| 783 | if [ "$always_clean" = "yes" ]; then |
| 784 | echo "${TEST_NAME} files deleted from host " |
| 785 | if [ "$target_mode" == "yes" ]; then |
| 786 | echo "and from target" |
| 787 | fi |
| 788 | else |
| 789 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 790 | if [ "$target_mode" == "yes" ]; then |
| 791 | echo "and in ${DEX_LOCATION} on target" |
| 792 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 793 | fi |
| 794 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 795 | ) 1>&2 |
| 796 | |
| 797 | exit 1 |